Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/HeuristicLab.DataPreprocessing-3.3.csproj
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/HeuristicLab.DataPreprocessing-3.3.csproj	(revision 10369)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/HeuristicLab.DataPreprocessing-3.3.csproj	(revision 10370)
@@ -219,9 +219,4 @@
     </ProjectReference>
   </ItemGroup>
-  <ItemGroup>
-    <EmbeddedResource Include="Views\StatisticsView.resx">
-      <DependentUpon>StatisticsView.cs</DependentUpon>
-    </EmbeddedResource>
-  </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <PropertyGroup>
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/StatisticsContent.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/StatisticsContent.cs	(revision 10369)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/StatisticsContent.cs	(revision 10370)
@@ -1,46 +1,29 @@
-﻿using HeuristicLab.Common;
+﻿using System.Drawing;
+using HeuristicLab.Common;
 using HeuristicLab.Core;
-using System.Drawing;
-using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
 
-namespace HeuristicLab.DataPreprocessing
-{
+namespace HeuristicLab.DataPreprocessing {
   [Item("Statistics", "Represents the statistics grid.")]
-  public class StatisticsContent : Item
-  {
+  public class StatisticsContent : Item {
 
     private readonly IStatisticsLogic statisticsLogic;
-    private readonly IDataGridLogic dataGridLogic;
-    public StatisticsContent(IStatisticsLogic theStatisticsLogic, IDataGridLogic theDataGridLogic)
-    {
+    public StatisticsContent(IStatisticsLogic theStatisticsLogic) {
       statisticsLogic = theStatisticsLogic;
-      dataGridLogic = theDataGridLogic;
     }
 
     public StatisticsContent(StatisticsContent content, Cloner cloner)
-      : base(content, cloner)
-    {
+      : base(content, cloner) {
 
     }
 
-    public IStatisticsLogic StatisticsLogic
-    {
+    public IStatisticsLogic StatisticsLogic {
       get { return statisticsLogic; }
     }
 
-    public IDataGridLogic DataDridLogic {
-      get { return dataGridLogic; }
-    }
-
-    public static new Image StaticItemImage
-    {
+    public static new Image StaticItemImage {
       get { return HeuristicLab.Common.Resources.VSImageLibrary.Statistics; }
     }
 
-    public override IDeepCloneable Clone(Cloner cloner)
-    {
+    public override IDeepCloneable Clone(Cloner cloner) {
       return new StatisticsContent(this, cloner);
     }
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Views/StatisticsView.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Views/StatisticsView.cs	(revision 10369)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Views/StatisticsView.cs	(revision 10370)
@@ -38,11 +38,10 @@
     }
     private void UpdateData() {
-      var statisticsLogic = Content.StatisticsLogic;
-      var dataGridLogic = Content.DataDridLogic;
-      txtRows.Text = statisticsLogic.GetRowCount().ToString();
-      txtColumns.Text = statisticsLogic.GetColumnCount().ToString();
-      txtNumericColumns.Text = statisticsLogic.GetNumericColumnCount().ToString();
-      txtNominalColumns.Text = statisticsLogic.GetNominalColumnCount().ToString();
-      txtMissingValuesTotal.Text = statisticsLogic.GetMissingValueCount().ToString();
+      var logic = Content.StatisticsLogic;
+      txtRows.Text = logic.GetRowCount().ToString();
+      txtColumns.Text = logic.GetColumnCount().ToString();
+      txtNumericColumns.Text = logic.GetNumericColumnCount().ToString();
+      txtNominalColumns.Text = logic.GetNominalColumnCount().ToString();
+      txtMissingValuesTotal.Text = logic.GetMissingValueCount().ToString();
 
       DataGridViewColumn[] columns = new DataGridViewColumn[COLUMNS];
@@ -51,5 +50,5 @@
 
 
-      for (int i = 0; i < Content.DataDridLogic.Columns; ++i) {
+      for (int i = 0; i < logic.GetColumnCount(); ++i) {
         var column = new DataGridViewTextBoxColumn();
         column.FillWeight = 1;
@@ -57,9 +56,9 @@
 
         List<string> list;
-        if (statisticsLogic.IsType<double>(i)) {
+        if (logic.IsType<double>(i)) {
           list = GetDoubleColumns(i);
-        } else if (statisticsLogic.IsType<string>(i)) {
+        } else if (logic.IsType<string>(i)) {
           list = GetStringColumns(i);
-        } else if (statisticsLogic.IsType<DateTime>(i)) {
+        } else if (logic.IsType<DateTime>(i)) {
           list = GetDateTimeColumns(i);
         } else {
@@ -100,5 +99,5 @@
 
     private void dataGridView_CellValueNeeded(object sender, DataGridViewCellValueEventArgs e) {
-      if (Content != null && e.RowIndex < columnsRowsMatrix.Count && e.ColumnIndex < Content.DataDridLogic.Columns) {
+      if (Content != null && e.RowIndex < columnsRowsMatrix.Count && e.ColumnIndex < Content.StatisticsLogic.GetColumnCount()) {
 
       }